var stmM = {
    _blockingNotHostOn: false,
    _blockingImagesOn: false,
    _blockType: 0,  //0: not in host, 1: all images

    onUIReadyDelayed: function(aEvent) {
        if (PageActions._handlers === null)
            PageActions.init();
        PageActions.register("stmmobile-block-nothost", stmM.updatePageAction, stmM);
        PageActions.register("stmmobile-block-images",  stmM.updatePageAction, stmM);

        addEventListener("AddonOptionsLoad", function(e) {stmM.initOptions(e);}, false);

        if (Services.prefs.getIntPref("extensions.stmmobile.loadInBackground") != 0)
            this.enableBackForeLoad(true);

        var num = Services.prefs.getIntPref("extensions.stmmobile.focusAfterCloseTab");
        if (num != 0) this.enableFocusAfterCloseTab(num);


        if (Services.prefs.getBoolPref("extensions.stmmobile.pageUpDownByDblClick"))
            this.enableDblClickListener(true);

        if (Services.prefs.getBoolPref("extensions.stmmobile.landscape"))
            this.enableLandscapeAlways(true);
    },

    initOptions: function(e) {
        if (e.target.id != "urn:mozilla:item:{7EF52AB8-79F8-4E4B-A7CC-DC5C2FFA4700}")
            return;

        let control1 = document.getElementById("e.loadInBackground");
        control1.value = Services.prefs.getIntPref('extensions.stmmobile.loadInBackground');

        let control2 = document.getElementById("e.focusAfterCloseTab");
        control2.value = Services.prefs.getIntPref('extensions.stmmobile.focusAfterCloseTab');
    },


    updatePageAction: function(aAction) {
        if (!Services.prefs.getBoolPref("extensions.stmmobile.quickBlock"))
            return false;

        let page = Browser.selectedBrowser.currentURI.spec;
        if (page.indexOf("about:") == 0)
            return false;

        var str1 = this._blockingNotHostOn?'Show All Not In Host':'Block All Not In Host';
        var str2 = this._blockingImagesOn?'Show All Images':'Block All Images';

        document.getElementById("stmmobile-block-nothost").setAttribute('title', str1);
        document.getElementById("stmmobile-block-images").setAttribute('title', str2);

        return true;
    },

    toggleBlock: function(pId) {
        this._blockType = pId;
        let serv = Components.classes['@mozilla.org/observer-service;1'].getService(Components.interfaces.nsIObserverService);
        switch (pId) {
            case 0: //not host
                if (!this._blockingNotHostOn && !this._blockingImagesOn) {
                    serv.addObserver(this.blockObserver, 'http-on-modify-request', false);
                    this._blockingNotHostOn = true;
                } else if (this._blockingNotHostOn) {
                    serv.removeObserver(stmM.blockObserver, 'http-on-modify-request', false);
                    this._blockingNotHostOn = false;
                } else {
                    this._blockingNotHostOn = true;
                }
                this._blockingImagesOn = false;
                break;
            case 1: //images
                if (!this._blockingNotHostOn && !this._blockingImagesOn) {
                    serv.addObserver(this.blockObserver, 'http-on-modify-request', false);
                    this._blockingImagesOn = true;
                } else if (this._blockingImagesOn) {
                    serv.removeObserver(stmM.blockObserver, 'http-on-modify-request', false);
                    this._blockingImagesOn = false;
                } else {
                    this._blockingImagesOn = true;
                }
                this._blockingNotHostOn = false;
                break;
        }
        Browser.selectedBrowser.reloadWithFlags(Components.interfaces.nsIRequest.LOAD_NORMAL);
    },


    blockObserver: {
        observe: function(aSubject, aTopic, aData) {
            aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
            if (this.isAllowed(aSubject.URI)) return;
            aSubject.cancel(Components.results.NS_ERROR_FAILURE);
        },

        isAllowed: function(uri) {
            switch(stmM._blockType) {
                case 0:  //not host
    
                  for (var i = 0; i < Browser._tabs.length; i++) {
                      let broURI = Browser._tabs[i].browser.currentURI;
                      if ((broURI.asciiHost == "" && broURI.spec != "about:home") || uri.asciiHost == broURI.asciiHost)
                          return true;
                  }
                  return false;
                case 1:  //pics
                  return this.ifIsNotPic(uri.spec);

            }
        },

        ifIsNotPic: function(url) {
            var exts = new Array("js", "gif", "jpg", "jpeg", "png", "swf", "svg", "bmp");
            for (var i in exts) {
                if (url.toLowerCase().indexOf("." + exts[i]) > -1)
                    return false;
            }
            return true;
        },
    },

    ////////////////////////////////////////
    enableBackForeLoad: function(aBool) {
        if (aBool)
            eval("Browser.addTab = " + Browser.addTab.toString().replace(
                'var params = aParams || {};',
                'aBringFront = stmM.getBackForeFlg(aBringFront, this.addTab.caller.name); let params = aParams || {};'
            ));
        else
            eval("Browser.addTab = " + Browser.addTab.toString().replace(
                'aBringFront = stmM.getBackForeFlg(aBringFront, this.addTab.caller.name);',
                ''
            ));
    },

    
    getBackForeFlg: function(aBringFront, callerName) {
        switch (Services.prefs.getIntPref('extensions.stmmobile.loadInBackground')) {
            case 0: //default
                return aBringFront;
            case 1: //background
                if (callerName == 'newTab' || callerName == 'loadURI'|| callerName == 'receiveMessage')
                    return aBringFront;
                else
                    return false;
            case 2: //foreground
                return true;
            default:
                return aBringFront
        }
    },

    ////////////////////////////////////////
    enableFocusAfterCloseTab: function(position) {
        let tabs = document.getElementById('tabs');
        if (position == 0) {
            eval("tabs.addTab = " + tabs.addTab.toString().replace(
                'return stmM.whereAddTab(tab, this);',
                'return tab;'
            ));
            eval("Browser._doCloseTab = " + Browser._doCloseTab.toString().replace(
                'nextTab = stmM.activateTab(aTab, nextTab);',
                ''
            ));
        } else {
            eval("tabs.addTab = " + tabs.addTab.toString().replace(
                'return tab;',
                'return stmM.whereAddTab(tab, this);'
            ));
            eval("Browser._doCloseTab = " + Browser._doCloseTab.toString().replace(
                'aTab.destroy();',
                'nextTab = stmM.activateTab(aTab, nextTab); aTab.destroy(); '
            ));
        }
    },

    whereAddTab: function(t, that) {
        var isBlankNewTab = false;
        try {
            var c4name = that.addTab.caller.caller.caller.caller.name;
            isBlankNewTab = "newTab"==c4name;
        } catch (ex) {}

        let tabs = document.getElementById('tabs');
        if (!isBlankNewTab && Browser._tabs.length >=2 ) {  //do not handle one tab
            var s = tabs.selectedTab;
            if (!s.hasAttribute("stmTabMark"))
                s.setAttribute("stmTabMark", Math.random());
            t.setAttribute("stmRightMark", s.getAttribute("stmTabMark"));
        }

        return t;
    },

    activateTab: function(aTab, aNextTab) {
        let tabs = document.getElementById('tabs');
        let tabArray = document.getElementById("tabs").children.childNodes;

        let aTabPos = Browser._tabs.indexOf(aTab);
        let aTab = tabArray[aTabPos];

        if (tabArray.length <= 2) return aNextTab;   //only 1 tab and will be removed.
        var wStmRightMark = aTab.getAttribute("stmRightMark");
        var wStmTabMark = aTab.getAttribute("stmTabMark");
        var wIndex = aTabPos
        switch (Services.prefs.getIntPref('extensions.stmmobile.focusAfterCloseTab')) {
            case 1: //left
              return Browser._tabs[wIndex==0?1:wIndex-1];
            case 2: //father, no father ->child first
              if (!wStmRightMark) break;
              var findex = this.getFatherTabIndex(wStmRightMark);
              if (findex >= 0) {return Browser._tabs[findex];}
              for(var i = 0; i < tabArray.length; i++) {
                  var ctab = tabArray[i];
                  if (ctab.getAttribute("stmRightMark") == wStmRightMark && ctab != aTab)
                      {return Browser._tabs[i];}
              }
              break;
            case 3: //father right first, if no, father
              if (!wStmRightMark) break;
              var findex = this.getFatherTabIndex(wStmRightMark);
              for(var i = (findex==-1?0:findex+1); i < tabArray.length; i++) {
                  var ctab = tabArray[i];
                  if (ctab.getAttribute("stmRightMark") == wStmRightMark && ctab != aTab)
                      {return Browser._tabs[i];}
              }
              if (findex >= 0) {return Browser._tabs[findex];}
              break;
            case 4: //father right farest, if no, father
              if (!wStmRightMark) break;
              var findex = this.getFatherTabIndex(wStmRightMark);
              var lchildtab;
              var lchildtabPos;
              for(var i = (findex==-1?0:findex+1); i < tabArray.length; i++) {
                  var ctab = tabArray[i];
                  if (ctab.getAttribute("stmRightMark") == wStmRightMark && ctab != aTab) {
                      lchildtab = ctab;
                      lchildtabPos = i;
                  }
              }
              if (lchildtab) {return Browser._tabs[lchildtabPos];}
              if (findex >= 0) {return Browser._tabs[findex];}
              break;
            case 5: //first
              return Browser._tabs[0];
            case 6: //last
              var length = tabArray.length;
              return Browser._tabs[(wIndex == length-1)?(wIndex-1):(length-1)];
            case 7: //last selected tab
              break;
            case 8: //author's like
              if (!wStmTabMark && !wStmRightMark) break;

              var ntabPos = (wIndex+1<tabArray.length)?wIndex+1:wIndex-1;
              var ntab = tabArray[ntabPos];
              var mark = ntab.getAttribute("stmRightMark");
              if (wStmTabMark && wStmTabMark == mark || wStmRightMark && wStmRightMark == mark)
                  return Browser._tabs[ntabPos];

              var ptabPos = (wIndex-1>=0)?wIndex-1:wIndex+1;
              var ptab = tabArray[ptabPos];
              mark = ptab.getAttribute("stmRightMark");
              var fmark = ptab.getAttribute("stmTabMark");
              if (wStmTabMark && wStmTabMark == mark || wStmRightMark && wStmRightMark == mark
               || fmark && fmark == wStmRightMark) {
                  return Browser._tabs[ptabPos];
              }
              break;
            case 9: //right
              return Browser._tabs[(wIndex>=tabArray.length-1)?wIndex-1:wIndex+1];
        }

        return aNextTab;   //default
    },

    getFatherTabIndex: function(pstmmark) {
        let tabArray = document.getElementById("tabs").children.childNodes;
        for(var i = 0; i < tabArray.length; i++) {
            var ctab = tabArray[i];
            if (ctab.getAttribute("stmTabMark") == pstmmark) return i;
        }
        return -1;
    },

    //////////////////////////////////////////
    enableDblClickListener: function(aBool) {
        if (aBool)
            eval("ContentTouchHandler.tapDouble = " + ContentTouchHandler.tapDouble.toString().replace(
                'this._clearPendingMessages();',
                'if (stmM.onMouseDoubleClick(aY)) return; this._clearPendingMessages();'
            ));
        else
            eval("ContentTouchHandler.tapDouble = " + ContentTouchHandler.tapDouble.toString().replace(
                'stmM.onMouseDoubleClick(aY)',
                'false'
            ));
    },

    onMouseDoubleClick: function(aY) {
        let height = ViewableAreaObserver.height / Browser.getScaleRatio();
        let oneOf5 = height / 5;
        let fourOf5 = height / 5 * 4;

        var win = document.commandDispatcher.focusedWindow;
        var view = getBrowser().getRootView();

        var rate = 0.95;
        if (aY < oneOf5)
            view.scrollBy(0, win.innerHeight * rate * -1);
        else if (aY > fourOf5) {
            let rect = Elements.browsers.getBoundingClientRect();
            Browser.hideTitlebar();
            view.scrollBy(0, win.innerHeight * rate - Math.round(rect.top));
        } else
            return false;

        return true;
    },

    enableLandscapeAlways: function(aBool) {
        let w = window.outerWidth;
        let h = window.outerHeight;
        let big = w>h?w:h;
        let small = w>h?h:w;

        if (aBool) {
            window.addEventListener("deviceorientation", function(e) {e.preventDefault();e.stopPropagation();}, true);

            window.top.resizeTo(big,small);

        } else {
            if (Util.isPortrait())
                window.top.resizeTo(big,small);
            else
                window.top.resizeTo(small,big);
        }
    },

};

window.addEventListener("UIReadyDelayed", function(e) {stmM.onUIReadyDelayed(e);}, false);
